package org.dromara.settlement.common.file;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Iterator;
import java.util.Properties;
import java.util.Vector;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.jcraft.jsch.Channel;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.ChannelSftp.LsEntry;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;
import com.jcraft.jsch.SftpException;

/**
 * SFTP上传下载文件
 */
public class SftpUtils {
	private final Logger logger = LoggerFactory.getLogger(SftpUtils.class);// SnowLog.getLogger(this.getClass());

	/**
	 * 连接sftp服务器
	 * @param host 主机
	 * @param port 端口
	 * @param username 用户名
	 * @param password 密码
	 * @return
	 */
	public ChannelSftp connect(String host, int port, String username, String password) {
		ChannelSftp sftp = null;
		Channel channel=null;
		Session sshSession=null;
		try {
			JSch jsch = new JSch();
			jsch.getSession(username, host, port);
			sshSession = jsch.getSession(username, host, port);
			if(logger.isInfoEnabled()){
				logger.info("***************** Session created. **********************");
				logger.info("***************** stf host is "+host+"port is "+port+"  username is "+username+"  password is  "+password+"**********************");
			}
			sshSession.setPassword(password);
			Properties sshConfig = new Properties();
			sshConfig.put("StrictHostKeyChecking", "no");
			sshSession.setConfig(sshConfig);
			sshSession.connect();
			if(logger.isInfoEnabled()){
				logger.info("***************** Session connected. **********************");
				logger.info("***************** Opening Channel. **********************");
			}
			channel = sshSession.openChannel("sftp");
			channel.connect();
			sftp = (ChannelSftp) channel;
			if(logger.isInfoEnabled()){
				logger.info("***************** Connected to " + host + ". **********************");
			}
		} catch (Throwable e) {
			if (channel!=null) {
				try {
					channel.disconnect();
				}catch(Throwable e1) {
				}
			}

			if (sshSession!=null) {
				try {
					sshSession.disconnect();
				}catch(Throwable e1) {
				}
			}

			logger.error(e.getMessage(), e);
		}
		return sftp;
	}

	/**
	 * 关闭连接
	 * @param sftp
	 */
	public void disconnect(String host, ChannelSftp sftp){
		// 关闭连接
		try {
			if (null != sftp) {
				sftp.disconnect();
				if(logger.isInfoEnabled()){
					logger.info("***************** Closing Channel. **********************");
				}
				if (null != sftp.getSession()) {
					sftp.getSession().disconnect();
					if(logger.isInfoEnabled()){
						logger.info("***************** Session disconnect. **********************");
					}
				}
			}
			if (logger.isInfoEnabled()) {
				logger.info("**************** Disconnect to " + host + ". *******************");
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 判断目录下是否存在文件或者文件夹
	 * @param directory
	 * @param fileName
	 * @param sftp
	 * @return
	 */
	public boolean isExist(String directory, String fileName, ChannelSftp sftp) {
		try {
			Vector<LsEntry> v = listFiles(directory, sftp);
			Iterator<LsEntry> it = v.iterator();
			while (it.hasNext()) {
				LsEntry entry = it.next();
				String flName = entry.getFilename();
				if (flName.equals(fileName)) {
					return true;
				}
			}
		} catch (SftpException e) {
			e.printStackTrace();
		}
		return false;
	}

	/**
	 * 上传文件
	 * @param directory 上传的目录
	 * @param uploadFile 要上传的文件
	 * @param sftp
	 */
	public String upload(String directory, String uploadFile, ChannelSftp sftp) {
		String successFlg = "0";
		try {
			sftp.cd(directory);
			File file = new File(uploadFile);
			sftp.put(new FileInputStream(file), file.getName());
			if(logger.isInfoEnabled()){
				logger.info("***************** Finished **********************");
			}
		} catch (Exception e) {
			successFlg = "1";
			e.printStackTrace();
		}
		return successFlg;
	}

	/**
	 * 下载文件
	 * @param directory 下载目录
	 * @param downloadFile 下载的文件
	 * @param saveFile 存在本地的路径
	 * @param sftp
	 */
	public boolean download(String directory, String downloadFile, String saveFile, ChannelSftp sftp) {
		try {
			sftp.cd(directory);
			File file = new File(saveFile);
			if(!file.getParentFile().exists()){
				file.getParentFile().mkdirs();
			}
			sftp.get(downloadFile, new FileOutputStream(file));
			if(logger.isInfoEnabled()){
				logger.info("***************** Finished **********************");
			}
			return true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	/**
	 * 删除文件
	 * @param directory 要删除文件所在目录
	 * @param deleteFile 要删除的文件
	 * @param sftp
	 */
	public void delete(String directory, String deleteFile, ChannelSftp sftp) {
		try {
			sftp.cd(directory);
			sftp.rm(deleteFile);
			if(logger.isInfoEnabled()){
				logger.info("***************** Finished **********************");
			}
			if (null != sftp) {
				sftp.disconnect();
				if (null != sftp.getSession()) {
					sftp.getSession().disconnect();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 列出目录下的文件
	 * @param directory  要列出的目录
	 * @param sftp
	 * @return
	 * @throws SftpException
	 */
	@SuppressWarnings("unchecked")
	public Vector<LsEntry> listFiles(String directory, ChannelSftp sftp) throws SftpException {
		return sftp.ls(directory);
	}

	/**
	 * 判断本地路径是否存在，不存在就创建路径
	 */
	public  void makeDirs(String localSavePath) {
		File localFile = new File(localSavePath);
		if (!localFile.exists()) {
			localFile.mkdirs();
		}
	}
}

